%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Hw10:  Detect Boundary of a Rabbit         %
%    Student: Bo Han                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step1: extract rabbit from background
img=imread('v4rabbit.jpeg');
red=img(:,:,1);
green=img(:,:,2);
[len,wid]=size(red);
rabbit=[];
for i=1:len
    for j=1:wid
        if (red(i,j)<green(i,j))
            rabbit(i,j)=1;
        else
            rabbit(i,j)=0;
        end
    end
end

%step2: close the object
se=strel('disk',7);
BW=imclose(imopen(rabbit,se),se);
imshow(BW);

%step3: detect boundary
  [B,L,N,A] = bwboundaries(BW);
       imshow(BW); 
       hold on;
       for k=1:length(B),
         if(~sum(A(k,:)))
           boundary = B{k};
           for l=find(A(:,k))'
             boundary = B{l};
             plot(boundary(:,2), boundary(:,1), 'r','LineWidth',2);
          end
       end
   end
   